#!/QOpenSys/usr/bin/sh

set -eu

if [ $# -lt 3 ]
then
  echo "$0: [NAME] [SONAME] [ARCH]"
  exit 1
fi

NAME=$1
SONAME=$2
ARCH=$3
# TMPDIR=$4

case "$ARCH" in 
  ppc64)
    IMP=shr_64.imp
    SO=shr_64.o
    OBJECT_MODE=64
    export OBJECT_MODE
    ;;
    
  ppc)
    IMP=shr.imp
    SO=shr.o
    OBJECT_MODE=32
    export OBJECT_MODE
    ;;
    
  *)
    echo Invalid arch
    exit 1
    ;;
esac


mv $NAME $SO

(
    echo '#! '"$SONAME($SO)"
    echo "# $OBJECT_MODE"
    dump -nv $SO | grep EXP | awk '{ print $NF }' | sort
) | sed '/__dso_handle/d; /__init_aix_libgcc_cxa_atexit/d' > $IMP

strip -e $SO
ar cr $NAME $IMP $SO
ranlib $NAME

rm $IMP $SO
